"
COPYRIGHT (c) 2020 LabWare

stx:libscm - a new source code management library for Smalltalk/X

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License. 

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
"
"{ Package: 'stx:libscm/common' }"

"{ NameSpace: Smalltalk }"

Object subclass:#SCMMergeTool
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SCM-Common-StX-Tools'
!

!SCMMergeTool class methodsFor:'documentation'!

copyright
"
COPYRIGHT (c) 2020 LabWare

stx:libscm - a new source code management library for Smalltalk/X

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License. 

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
"
!

documentation
"
    [author:]
        Jan Vrany <jan.vrany@labware.com>

    [instance variables:]

    [class variables:]

    [see also:]

"
! !

!SCMMergeTool methodsFor:'merging'!

base: baseFile local: localFile other: otherFile output: outputFile
    "Perform 3-way merge merging `localFile` and `otherFile` using `baseFile` to
     guide the merge. Merged contents (if merge is successfull) is saved into 
    `outputFile`. Return `true` if merge was successfull, false not.
    "
    | mergeInfo mergeTool |

    mergeInfo := Tools::ChangeSetDiffInfo
                    specA: (Tools::ChangeSetSpec file: localFile)
                    specB: (Tools::ChangeSetSpec file: otherFile)
                    specBase: (Tools::ChangeSetSpec file: baseFile)
                    specMerge: (Tools::ChangeSetSpec file: outputFile).
    mergeInfo read.

    "/ If it can be merged automatically, save the merge
    "/ and return.
    mergeInfo diffset isMerged ifTrue:[

        | merge |

        merge := mergeInfo diffset changesetMerged , mergeInfo same. 
        merge := merge reject:[:chg|chg isDoIt].
        merge saveToFile: outputFile format: #classSource.
        ^ true.
    ].

    "/ If not, open a UI tool and let the user to resolve 
    "/ conflicts, reporting back whether manual merge was
    "/ sucessfull or not...
    mergeTool := Tools::ChangeSetDiffTool new.  
    mergeTool fileMenuOpenOnDiffInfo: mergeInfo.
    mergeTool openModal.
    ^ mergeTool mergeSavedHolder value

    "Modified: / 27-08-2020 / 15:10:32 / Jan Vrany <jan.vrany@labware.com>"
! !

!SCMMergeTool class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

